/* Generated from ./cms.asn1 */
/* Do not edit */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <cms_asn1.h>
#include <asn1_err.h>
#include <der.h>
#include <parse_units.h>

int
encode_EncapsulatedContentInfo(unsigned char *p, size_t len, const EncapsulatedContentInfo *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* eContent */
if((data)->eContent) {
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_octet_string(p, len, (data)->eContent, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_OctetString, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 0, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* eContentType */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_ContentType(p, len, &(data)->eContentType, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int
decode_EncapsulatedContentInfo(const unsigned char *p, size_t len, EncapsulatedContentInfo *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
Der_type Top_type;
int is_indefinite;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &Top_type, UT_Sequence, &Top_datalen, &l);
if (e == 0 && Top_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if((is_indefinite = _heim_fix_dce(Top_datalen, &len)) < 0)
{ e = ASN1_BAD_FORMAT; goto fail; }
if (is_indefinite) { if (len < 2) { e = ASN1_OVERRUN; goto fail; } len -= 2; }e = decode_ContentType(p, len, &(data)->eContentType, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
{
size_t eContent_datalen, eContent_oldlen;
Der_type eContent_type;
int is_indefinite;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, &eContent_type, 0, &eContent_datalen, &l);
if (e == 0 && eContent_type != CONS) { e = ASN1_BAD_ID; }
if(e) {
(data)->eContent = NULL;
} else {
(data)->eContent = calloc(1, sizeof(*(data)->eContent));
if ((data)->eContent == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
eContent_oldlen = len;
if((is_indefinite = _heim_fix_dce(eContent_datalen, &len)) < 0)
{ e = ASN1_BAD_FORMAT; goto fail; }
if (is_indefinite) { if (len < 2) { e = ASN1_OVERRUN; goto fail; } len -= 2; }{
size_t eContent_Tag_datalen, eContent_Tag_oldlen;
Der_type eContent_Tag_type;
int is_indefinite;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &eContent_Tag_type, UT_OctetString, &eContent_Tag_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
eContent_Tag_oldlen = len;
if((is_indefinite = _heim_fix_dce(eContent_Tag_datalen, &len)) < 0)
{ e = ASN1_BAD_FORMAT; goto fail; }
if (is_indefinite) { if (len < 2) { e = ASN1_OVERRUN; goto fail; } len -= 2; }if (eContent_Tag_type == CONS) {
e = der_get_octet_string_ber(p, len, (data)->eContent, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
} else {
e = der_get_octet_string(p, len, (data)->eContent, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
}
if(is_indefinite){
len += 2;
e = der_match_tag_and_length(p, len, (Der_class)0, &eContent_Tag_type, UT_EndOfContent, &eContent_Tag_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
if (eContent_Tag_type != (Der_type)0) { e = ASN1_BAD_ID; goto fail; }
} else 
len = eContent_Tag_oldlen - eContent_Tag_datalen;
}
if(is_indefinite){
len += 2;
e = der_match_tag_and_length(p, len, (Der_class)0, &eContent_type, UT_EndOfContent, &eContent_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
if (eContent_type != (Der_type)0) { e = ASN1_BAD_ID; goto fail; }
} else 
len = eContent_oldlen - eContent_datalen;
}
}
if(is_indefinite){
len += 2;
e = der_match_tag_and_length(p, len, (Der_class)0, &Top_type, UT_EndOfContent, &Top_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
if (Top_type != (Der_type)0) { e = ASN1_BAD_ID; goto fail; }
} else 
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_EncapsulatedContentInfo(data);
return e;
}

void
free_EncapsulatedContentInfo(EncapsulatedContentInfo *data)
{
free_ContentType(&(data)->eContentType);
if((data)->eContent) {
der_free_octet_string((data)->eContent);
free((data)->eContent);
(data)->eContent = NULL;
}
}

size_t
length_EncapsulatedContentInfo(const EncapsulatedContentInfo *data)
{
size_t ret = 0;
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_ContentType(&(data)->eContentType);
ret += Top_tag_oldret;
}
if((data)->eContent){
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_octet_string((data)->eContent);
ret += 1 + der_length_len (ret);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int
copy_EncapsulatedContentInfo(const EncapsulatedContentInfo *from, EncapsulatedContentInfo *to)
{
memset(to, 0, sizeof(*to));
if(copy_ContentType(&(from)->eContentType, &(to)->eContentType)) goto fail;
if((from)->eContent) {
(to)->eContent = malloc(sizeof(*(to)->eContent));
if((to)->eContent == NULL) goto fail;
if(der_copy_octet_string((from)->eContent, (to)->eContent)) goto fail;
}else
(to)->eContent = NULL;
return 0;
fail:
free_EncapsulatedContentInfo(to);
return ENOMEM;
}



