/* Generated from ./rfc2459.asn1 */
/* Do not edit */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <rfc2459_asn1.h>
#include <asn1_err.h>
#include <der.h>
#include <parse_units.h>

int
encode_Extension(unsigned char *p, size_t len, const Extension *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* extnValue */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_octet_string(p, len, &(data)->extnValue, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_OctetString, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* critical */
if((data)->critical) {
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_boolean(p, len, (data)->critical, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_Boolean, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* extnID */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_oid(p, len, &(data)->extnID, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_OID, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int
decode_Extension(const unsigned char *p, size_t len, Extension *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
Der_type Top_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &Top_type, UT_Sequence, &Top_datalen, &l);
if (e == 0 && Top_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
{
size_t extnID_datalen, extnID_oldlen;
Der_type extnID_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &extnID_type, UT_OID, &extnID_datalen, &l);
if (e == 0 && extnID_type != PRIM) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
extnID_oldlen = len;
if (extnID_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = extnID_datalen;
e = der_get_oid(p, len, &(data)->extnID, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = extnID_oldlen - extnID_datalen;
}
{
size_t critical_datalen, critical_oldlen;
Der_type critical_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &critical_type, UT_Boolean, &critical_datalen, &l);
if (e == 0 && critical_type != PRIM) { e = ASN1_BAD_ID; }
if(e) {
(data)->critical = NULL;
} else {
(data)->critical = calloc(1, sizeof(*(data)->critical));
if ((data)->critical == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
critical_oldlen = len;
if (critical_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = critical_datalen;
e = der_get_boolean(p, len, (data)->critical, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = critical_oldlen - critical_datalen;
}
}
{
size_t extnValue_datalen, extnValue_oldlen;
Der_type extnValue_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &extnValue_type, UT_OctetString, &extnValue_datalen, &l);
if (e == 0 && extnValue_type != PRIM) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
extnValue_oldlen = len;
if (extnValue_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = extnValue_datalen;
e = der_get_octet_string(p, len, &(data)->extnValue, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = extnValue_oldlen - extnValue_datalen;
}
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_Extension(data);
return e;
}

void
free_Extension(Extension *data)
{
der_free_oid(&(data)->extnID);
if((data)->critical) {
free((data)->critical);
(data)->critical = NULL;
}
der_free_octet_string(&(data)->extnValue);
}

size_t
length_Extension(const Extension *data)
{
size_t ret = 0;
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_oid(&(data)->extnID);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
if((data)->critical){
size_t Top_tag_oldret = ret;
ret = 0;
ret += 1;
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_octet_string(&(data)->extnValue);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int
copy_Extension(const Extension *from, Extension *to)
{
memset(to, 0, sizeof(*to));
if(der_copy_oid(&(from)->extnID, &(to)->extnID)) goto fail;
if((from)->critical) {
(to)->critical = malloc(sizeof(*(to)->critical));
if((to)->critical == NULL) goto fail;
*((to)->critical) = *((from)->critical);
}else
(to)->critical = NULL;
if(der_copy_octet_string(&(from)->extnValue, &(to)->extnValue)) goto fail;
return 0;
fail:
free_Extension(to);
return ENOMEM;
}



