/* Generated from ./cms.asn1 */
/* Do not edit */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <cms_asn1.h>
#include <asn1_err.h>
#include <der.h>
#include <parse_units.h>

int
encode_KeyTransRecipientInfo(unsigned char *p, size_t len, const KeyTransRecipientInfo *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* encryptedKey */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_EncryptedKey(p, len, &(data)->encryptedKey, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* keyEncryptionAlgorithm */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_KeyEncryptionAlgorithmIdentifier(p, len, &(data)->keyEncryptionAlgorithm, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* rid */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_RecipientIdentifier(p, len, &(data)->rid, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* version */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_CMSVersion(p, len, &(data)->version, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int
decode_KeyTransRecipientInfo(const unsigned char *p, size_t len, KeyTransRecipientInfo *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
Der_type Top_type;
int is_indefinite;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &Top_type, UT_Sequence, &Top_datalen, &l);
if (e == 0 && Top_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if((is_indefinite = _heim_fix_dce(Top_datalen, &len)) < 0)
{ e = ASN1_BAD_FORMAT; goto fail; }
if (is_indefinite) { if (len < 2) { e = ASN1_OVERRUN; goto fail; } len -= 2; }e = decode_CMSVersion(p, len, &(data)->version, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
e = decode_RecipientIdentifier(p, len, &(data)->rid, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
e = decode_KeyEncryptionAlgorithmIdentifier(p, len, &(data)->keyEncryptionAlgorithm, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
e = decode_EncryptedKey(p, len, &(data)->encryptedKey, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
if(is_indefinite){
len += 2;
e = der_match_tag_and_length(p, len, (Der_class)0, &Top_type, UT_EndOfContent, &Top_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
if (Top_type != (Der_type)0) { e = ASN1_BAD_ID; goto fail; }
} else 
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_KeyTransRecipientInfo(data);
return e;
}

void
free_KeyTransRecipientInfo(KeyTransRecipientInfo *data)
{
free_CMSVersion(&(data)->version);
free_RecipientIdentifier(&(data)->rid);
free_KeyEncryptionAlgorithmIdentifier(&(data)->keyEncryptionAlgorithm);
free_EncryptedKey(&(data)->encryptedKey);
}

size_t
length_KeyTransRecipientInfo(const KeyTransRecipientInfo *data)
{
size_t ret = 0;
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_CMSVersion(&(data)->version);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_RecipientIdentifier(&(data)->rid);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_KeyEncryptionAlgorithmIdentifier(&(data)->keyEncryptionAlgorithm);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_EncryptedKey(&(data)->encryptedKey);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int
copy_KeyTransRecipientInfo(const KeyTransRecipientInfo *from, KeyTransRecipientInfo *to)
{
memset(to, 0, sizeof(*to));
if(copy_CMSVersion(&(from)->version, &(to)->version)) goto fail;
if(copy_RecipientIdentifier(&(from)->rid, &(to)->rid)) goto fail;
if(copy_KeyEncryptionAlgorithmIdentifier(&(from)->keyEncryptionAlgorithm, &(to)->keyEncryptionAlgorithm)) goto fail;
if(copy_EncryptedKey(&(from)->encryptedKey, &(to)->encryptedKey)) goto fail;
return 0;
fail:
free_KeyTransRecipientInfo(to);
return ENOMEM;
}



