/* Generated from ./krb5.asn1 */
/* Do not edit */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <krb5_asn1.h>
#include <asn1_err.h>
#include <der.h>
#include <parse_units.h>

int
encode_KrbFastArmoredReq(unsigned char *p, size_t len, const KrbFastArmoredReq *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* enc-fast-req */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_EncryptedData(p, len, &(data)->enc_fast_req, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 2, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* req-checksum */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_Checksum(p, len, &(data)->req_checksum, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 1, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* armor */
if((data)->armor) {
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_KrbFastArmor(p, len, (data)->armor, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 0, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int
decode_KrbFastArmoredReq(const unsigned char *p, size_t len, KrbFastArmoredReq *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
Der_type Top_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &Top_type, UT_Sequence, &Top_datalen, &l);
if (e == 0 && Top_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
{
size_t armor_datalen, armor_oldlen;
Der_type armor_type;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, &armor_type, 0, &armor_datalen, &l);
if (e == 0 && armor_type != CONS) { e = ASN1_BAD_ID; }
if(e) {
(data)->armor = NULL;
} else {
(data)->armor = calloc(1, sizeof(*(data)->armor));
if ((data)->armor == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
armor_oldlen = len;
if (armor_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = armor_datalen;
e = decode_KrbFastArmor(p, len, (data)->armor, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = armor_oldlen - armor_datalen;
}
}
{
size_t req_checksum_datalen, req_checksum_oldlen;
Der_type req_checksum_type;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, &req_checksum_type, 1, &req_checksum_datalen, &l);
if (e == 0 && req_checksum_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
req_checksum_oldlen = len;
if (req_checksum_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = req_checksum_datalen;
e = decode_Checksum(p, len, &(data)->req_checksum, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = req_checksum_oldlen - req_checksum_datalen;
}
{
size_t enc_fast_req_datalen, enc_fast_req_oldlen;
Der_type enc_fast_req_type;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, &enc_fast_req_type, 2, &enc_fast_req_datalen, &l);
if (e == 0 && enc_fast_req_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
enc_fast_req_oldlen = len;
if (enc_fast_req_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = enc_fast_req_datalen;
e = decode_EncryptedData(p, len, &(data)->enc_fast_req, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = enc_fast_req_oldlen - enc_fast_req_datalen;
}
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_KrbFastArmoredReq(data);
return e;
}

void
free_KrbFastArmoredReq(KrbFastArmoredReq *data)
{
if((data)->armor) {
free_KrbFastArmor((data)->armor);
free((data)->armor);
(data)->armor = NULL;
}
free_Checksum(&(data)->req_checksum);
free_EncryptedData(&(data)->enc_fast_req);
}

size_t
length_KrbFastArmoredReq(const KrbFastArmoredReq *data)
{
size_t ret = 0;
if((data)->armor){
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_KrbFastArmor((data)->armor);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_Checksum(&(data)->req_checksum);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_EncryptedData(&(data)->enc_fast_req);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int
copy_KrbFastArmoredReq(const KrbFastArmoredReq *from, KrbFastArmoredReq *to)
{
memset(to, 0, sizeof(*to));
if((from)->armor) {
(to)->armor = malloc(sizeof(*(to)->armor));
if((to)->armor == NULL) goto fail;
if(copy_KrbFastArmor((from)->armor, (to)->armor)) goto fail;
}else
(to)->armor = NULL;
if(copy_Checksum(&(from)->req_checksum, &(to)->req_checksum)) goto fail;
if(copy_EncryptedData(&(from)->enc_fast_req, &(to)->enc_fast_req)) goto fail;
return 0;
fail:
free_KrbFastArmoredReq(to);
return ENOMEM;
}



