/* Generated from ./pkcs12.asn1 */
/* Do not edit */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <pkcs12_asn1.h>
#include <asn1_err.h>
#include <der.h>
#include <parse_units.h>

int
encode_PKCS12_SafeBag(unsigned char *p, size_t len, const PKCS12_SafeBag *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* bagAttributes */
if((data)->bagAttributes) {
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_PKCS12_Attributes(p, len, (data)->bagAttributes, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* bagValue */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_heim_any(p, len, &(data)->bagValue, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 0, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* bagId */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_oid(p, len, &(data)->bagId, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_OID, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int
decode_PKCS12_SafeBag(const unsigned char *p, size_t len, PKCS12_SafeBag *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
Der_type Top_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &Top_type, UT_Sequence, &Top_datalen, &l);
if (e == 0 && Top_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
{
size_t bagId_datalen, bagId_oldlen;
Der_type bagId_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &bagId_type, UT_OID, &bagId_datalen, &l);
if (e == 0 && bagId_type != PRIM) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
bagId_oldlen = len;
if (bagId_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = bagId_datalen;
e = der_get_oid(p, len, &(data)->bagId, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = bagId_oldlen - bagId_datalen;
}
{
size_t bagValue_datalen, bagValue_oldlen;
Der_type bagValue_type;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, &bagValue_type, 0, &bagValue_datalen, &l);
if (e == 0 && bagValue_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
bagValue_oldlen = len;
if (bagValue_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = bagValue_datalen;
e = decode_heim_any(p, len, &(data)->bagValue, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = bagValue_oldlen - bagValue_datalen;
}
(data)->bagAttributes = calloc(1, sizeof(*(data)->bagAttributes));
if ((data)->bagAttributes == NULL) goto fail;
e = decode_PKCS12_Attributes(p, len, (data)->bagAttributes, &l);
if(e) {
free((data)->bagAttributes);
(data)->bagAttributes = NULL;
} else {
p += l; len -= l; ret += l;
}
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_PKCS12_SafeBag(data);
return e;
}

void
free_PKCS12_SafeBag(PKCS12_SafeBag *data)
{
der_free_oid(&(data)->bagId);
free_heim_any(&(data)->bagValue);
if((data)->bagAttributes) {
free_PKCS12_Attributes((data)->bagAttributes);
free((data)->bagAttributes);
(data)->bagAttributes = NULL;
}
}

size_t
length_PKCS12_SafeBag(const PKCS12_SafeBag *data)
{
size_t ret = 0;
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_oid(&(data)->bagId);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_heim_any(&(data)->bagValue);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
if((data)->bagAttributes){
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_PKCS12_Attributes((data)->bagAttributes);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int
copy_PKCS12_SafeBag(const PKCS12_SafeBag *from, PKCS12_SafeBag *to)
{
memset(to, 0, sizeof(*to));
if(der_copy_oid(&(from)->bagId, &(to)->bagId)) goto fail;
if(copy_heim_any(&(from)->bagValue, &(to)->bagValue)) goto fail;
if((from)->bagAttributes) {
(to)->bagAttributes = malloc(sizeof(*(to)->bagAttributes));
if((to)->bagAttributes == NULL) goto fail;
if(copy_PKCS12_Attributes((from)->bagAttributes, (to)->bagAttributes)) goto fail;
}else
(to)->bagAttributes = NULL;
return 0;
fail:
free_PKCS12_SafeBag(to);
return ENOMEM;
}



