/* Generated from ./rfc2459.asn1 */
/* Do not edit */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <rfc2459_asn1.h>
#include <asn1_err.h>
#include <der.h>
#include <parse_units.h>

int
encode_RSAPublicKey(unsigned char *p, size_t len, const RSAPublicKey *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* publicExponent */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_heim_integer(p, len, &(data)->publicExponent, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_Integer, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* modulus */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_heim_integer(p, len, &(data)->modulus, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_Integer, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int
decode_RSAPublicKey(const unsigned char *p, size_t len, RSAPublicKey *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
Der_type Top_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &Top_type, UT_Sequence, &Top_datalen, &l);
if (e == 0 && Top_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
{
size_t modulus_datalen, modulus_oldlen;
Der_type modulus_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &modulus_type, UT_Integer, &modulus_datalen, &l);
if (e == 0 && modulus_type != PRIM) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
modulus_oldlen = len;
if (modulus_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = modulus_datalen;
e = der_get_heim_integer(p, len, &(data)->modulus, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = modulus_oldlen - modulus_datalen;
}
{
size_t publicExponent_datalen, publicExponent_oldlen;
Der_type publicExponent_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &publicExponent_type, UT_Integer, &publicExponent_datalen, &l);
if (e == 0 && publicExponent_type != PRIM) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
publicExponent_oldlen = len;
if (publicExponent_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = publicExponent_datalen;
e = der_get_heim_integer(p, len, &(data)->publicExponent, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = publicExponent_oldlen - publicExponent_datalen;
}
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_RSAPublicKey(data);
return e;
}

void
free_RSAPublicKey(RSAPublicKey *data)
{
der_free_heim_integer(&(data)->modulus);
der_free_heim_integer(&(data)->publicExponent);
}

size_t
length_RSAPublicKey(const RSAPublicKey *data)
{
size_t ret = 0;
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_heim_integer(&(data)->modulus);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_heim_integer(&(data)->publicExponent);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int
copy_RSAPublicKey(const RSAPublicKey *from, RSAPublicKey *to)
{
memset(to, 0, sizeof(*to));
if(der_copy_heim_integer(&(from)->modulus, &(to)->modulus)) goto fail;
if(der_copy_heim_integer(&(from)->publicExponent, &(to)->publicExponent)) goto fail;
return 0;
fail:
free_RSAPublicKey(to);
return ENOMEM;
}



